/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.vse.keg.ontologymanager;

import com.hp.hpl.jena.rdf.model.Model;
import com.hp.hpl.jena.rdf.model.ModelFactory;
import com.hp.hpl.jena.rdf.model.RDFNode;
import com.hp.hpl.jena.rdf.model.ResourceFactory;
import com.hp.hpl.jena.rdf.model.SimpleSelector;
import com.hp.hpl.jena.rdf.model.StmtIterator;
import com.hp.hpl.jena.util.FileManager;
import java.io.InputStream;

/**
 *
 * @author Milan
 */
public class DBpediaOntologyManager {
    
    private static DBpediaOntologyManager instance = null;
    private static String ontologyLocation = null;
    private static Model model = null;
    
    public static DBpediaOntologyManager getInstance() {

        if(instance == null){
            model = ModelFactory.createDefaultModel();
            InputStream in = FileManager.get().open( getOntologyLocation());
            model.read(in, null, "RDF/XML");         
            instance = new DBpediaOntologyManager();        
        }
        return instance;
    }

    /**
     * @return the ontologyLocation
     */
    public static String getOntologyLocation() {
        return ontologyLocation;
    }

    /**
     * @param aOntologyLocation the ontologyLocation to set
     */
    public static void setOntologyLocation(String aOntologyLocation) {
        ontologyLocation = aOntologyLocation;
    }

    public int doSuperclassComparison(String srcRes, String tarRes) {
        
        if(srcRes.equals(tarRes)) {
            return 0;
        }
        
        String srcTmpRes = srcRes;
        StmtIterator iter;
        boolean continueSearch = true;
        int distanceCounter = 0;
        
        while(continueSearch){
            
            continueSearch = false;
            distanceCounter++;
            iter = model.listStatements( new SimpleSelector(ResourceFactory.createResource(srcTmpRes), ResourceFactory.createProperty("http://www.w3.org/2000/01/rdf-schema#subClassOf"),  (RDFNode)null));
            
            while (iter.hasNext()) {
                continueSearch = true;
                srcTmpRes = iter.next().getObject().toString();
                
                if(srcTmpRes.equals(tarRes)){
                    continueSearch = false;
                    return distanceCounter;
                }
            }
        }
        return -1;
    }
    
    public int rootDistance(String res){
        
        StmtIterator iter;
        boolean continueSearch = true;
        int distanceCounter = 0;
        
        while(continueSearch){
            
            continueSearch = false;
            iter = model.listStatements( new SimpleSelector(ResourceFactory.createResource(res), ResourceFactory.createProperty("http://www.w3.org/2000/01/rdf-schema#subClassOf"),  (RDFNode)null));
            
            while (iter.hasNext()) {
                distanceCounter++;
                continueSearch = true;
                res = iter.next().getObject().toString();
            }        
        }
        return distanceCounter;
    }
}
