/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package cz.vse.keg.ontologymanager;

import gate.Corpus;
import gate.Document;
import gate.Factory;
import gate.ProcessingResource;
import gate.Resource;
import gate.creole.AbstractLanguageAnalyser;
import gate.creole.ExecutionException;
import gate.creole.ResourceInstantiationException;
import java.io.BufferedReader;
import java.io.FileReader;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 * @author Milan Dojchinovski
 * <milan (at) dojchinovski (dot) mk>
 * Twitter: @m1ci
 * www: http://dojchinovski.mk
 */
public class OntologyAwareFeatureDiffPR extends AbstractLanguageAnalyser implements ProcessingResource {

    private String dbpediaOntologyLocation;    
    private String gtAnnotationName;
    private String targetAnnotationName;
    private String gtASName;
    private String targetASName;
    private String ontologyTypeFeatureName;
    
    public OntologyAwareFeatureDiffPR() {
    }

    @Override
    public Resource init() throws ResourceInstantiationException {        
        System.out.println("OntologyAwarePR was successfully initialized.");
        return super.init();
    }
    
    @Override
    public void reInit() throws ResourceInstantiationException {
        init();
    }
        
    @Override
    public void execute() throws ExecutionException {
        Document doc = getDocument();
        TextProcessor.getInstance(dbpediaOntologyLocation).processDocument(doc, gtASName, targetASName, gtAnnotationName, targetAnnotationName);
    }
    
    @Override
    public Corpus getCorpus() {
        return corpus;
    }

    @Override
    public void setCorpus(Corpus corpus) {
        this.corpus = corpus;
    }

    /**
     * @return the dbpediaOntologyLocation
     */
    public String getDbpediaOntologyLocation() {
        return dbpediaOntologyLocation;
    }

    /**
     * @param dbpediaOntologyLocation the dbpediaOntologyLocation to set
     */
    public void setDbpediaOntologyLocation(String dbpediaOntologyLocation) {
        this.dbpediaOntologyLocation = dbpediaOntologyLocation;
    }

    /**
     * @return the gtAnnotationName
     */
    public String getGtAnnotationName() {
        return gtAnnotationName;
    }

    /**
     * @param gtAnnotationName the gtAnnotationName to set
     */
    public void setGtAnnotationName(String gtAnnotationName) {
        this.gtAnnotationName = gtAnnotationName;
    }

    /**
     * @return the targetAnnotationName
     */
    public String getTargetAnnotationName() {
        return targetAnnotationName;
    }

    /**
     * @param targetAnnotationName the targetAnnotationName to set
     */
    public void setTargetAnnotationName(String targetAnnotationName) {
        this.targetAnnotationName = targetAnnotationName;
    }

    /**
     * @return the ontologyTypeFeatureName
     */
    public String getOntologyTypeFeatureName() {
        return ontologyTypeFeatureName;
    }

    /**
     * @param ontologyTypeFeatureName the ontologyTypeFeatureName to set
     */
    public void setOntologyTypeFeatureName(String ontologyTypeFeatureName) {
        this.ontologyTypeFeatureName = ontologyTypeFeatureName;
    }

    /**
     * @return the gtASName
     */
    public String getGtASName() {
        return gtASName;
    }

    /**
     * @param gtASName the gtASName to set
     */
    public void setGtASName(String gtASName) {
        this.gtASName = gtASName;
    }

    /**
     * @return the targetASName
     */
    public String getTargetASName() {
        return targetASName;
    }

    /**
     * @param targetASName the targetASName to set
     */
    public void setTargetASName(String targetASName) {
        this.targetASName = targetASName;
    }
}
