/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.vse.keg.thd.client;

import cz.vse.keg.ontologymanager.DBpediaOntologyManager;
import gate.AnnotationSet;
import gate.Document;
import gate.FeatureMap;
import java.io.BufferedReader;
import java.io.ByteArrayInputStream;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.Reader;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

/**
 *
 * @author Milan
 */
public class TextProcessor {
    
    private static int counter = 0;
    private static TextProcessor textProcessor = null;
    
    public static TextProcessor getInstance(){
        if(textProcessor == null){
            textProcessor = new TextProcessor();
        }
        return textProcessor;
    }
    
    public void processDocument(
            Document doc,
            String apikey,
            String outputASName,
            String annotationsName,
            String knowledgeBase,
            String entityType,
            String lang,
            String provenance,
            String longEntityLinking){
        
        try {
            // following words/chars should be removed from the ground-truth dataset
            ArrayList<String> blackList = new ArrayList();
            blackList.add("RT");
            blackList.add("URL");
            blackList.add("Mention");
            blackList.add("i");
            blackList.add("HASHTAG");

            String path = "http://ner.vse.cz/thd/api/v1/extraction?apikey="+apikey+"&format=xml";
//            String path = "http://localhost:8080/thd/api/v1/extraction?apikey="+apikey+"&format=xml";
            if(knowledgeBase != null){
                path += "&knowledge_base="+knowledgeBase;
            }
            if(entityType != null){
                path += "&entity_type="+entityType;
            }
            if(lang != null){
                path += "&lang="+lang;
            }
            if(provenance != null){
                path += "&provenance="+provenance;
            }
            if(longEntityLinking != null){
                path += "&priority_entity_linking="+longEntityLinking;
            }

            URL url = new URL(path);
            counter++;
//            System.out.println(counter + ": " + path);
            StringBuffer buffer = new StringBuffer();
            HttpURLConnection connection = (HttpURLConnection) url.openConnection();
            connection.setRequestMethod("POST");
            connection.setRequestProperty("Content-type", "text/plain; charset=UTF-8");
            connection.setDoOutput(true);
            connection.setDoInput(true);
            
            OutputStream os = connection.getOutputStream();
            os.write(doc.getContent().toString().getBytes("UTF-8"));
            os.flush();
            os.close();

            InputStream is = connection.getInputStream();
            Reader isr = new InputStreamReader(is,"UTF-8");
            Reader in = new BufferedReader(isr);
            int ch;

            while ((ch = in.read()) > -1) {
                buffer.append((char) ch);
            }
            in.close();
            isr.close();
            String result = buffer.toString();
//            System.out.println(result);
            AnnotationSet thdAnnots = doc.getAnnotations(outputASName);
            
            DocumentBuilderFactory dbFactory = DocumentBuilderFactory.newInstance();
            DocumentBuilder dBuilder = dbFactory.newDocumentBuilder();
            org.w3c.dom.Document xmldoc = (org.w3c.dom.Document) dBuilder.parse(new ByteArrayInputStream(result.getBytes()));
            NodeList eList = xmldoc.getElementsByTagName("entity");
                    
            for (int i = 0; i < eList.getLength(); i++) {
                
                Node nEntity = eList.item(i);

                if (nEntity.getNodeType() == Node.ELEMENT_NODE) {
                            
                    Element entity = (Element)nEntity;
                    String foundEntityType = entity.getElementsByTagName("entityType").item(0).getTextContent();
                    long startOffset = Long.parseLong(entity.getElementsByTagName("startOffset").item(0).getTextContent());
                    long endOffset = Long.parseLong(entity.getElementsByTagName("endOffset").item(0).getTextContent());
                    NodeList underlyingStringObj = entity.getElementsByTagName("underlyingString");
                    
                    if(underlyingStringObj.getLength() > 0) {
                        String underlyingString = underlyingStringObj.item(0).getTextContent();
                        
                        if(!blackList.contains(underlyingString)) {
                            
                            int rootDistance = -1;
                            NodeList tList = entity.getElementsByTagName("type");
                            FeatureMap fm = gate.Factory.newFeatureMap();

                            boolean found = false;

                            for (int j = 0; j < tList.getLength(); j++) {

                                Node nType = tList.item(j);

                                if (nType.getNodeType() == Node.ELEMENT_NODE) {

                                    Element type = (Element)nType;

                                    Node entityLabel = type.getElementsByTagName("entityLabel").item(0);
                                    Node entityURI = type.getElementsByTagName("entityURI").item(0);

                                    if(entityLabel != null && entityURI != null) {

                                        fm.put("entity", entityLabel.getTextContent());
                                        fm.put("entityURI", entityURI.getTextContent());
                                        fm.put("entityType", foundEntityType);
//                                        found = true;
                                    }

                                    Node typeLabel = type.getElementsByTagName("typeLabel").item(0);
                                    Node typeURI = type.getElementsByTagName("typeURI").item(0);

                                    if(typeLabel != null && typeURI != null) {

                                        if(typeURI.getTextContent().startsWith("http://dbpedia.org/ontology/")) {

                                            int currentRootDistance = DBpediaOntologyManager.getInstance().rootDistance(typeURI.getTextContent());

                                            if(currentRootDistance > rootDistance ) {
                                                rootDistance = currentRootDistance;
                                                fm.put("typeLabel", typeLabel.getTextContent());
                                                fm.put("typeURI", typeURI.getTextContent());
                                                fm.put("entityType", foundEntityType);
                                                found = true;
                                            }
                                        } else {
                                            fm.put("typeLabel", typeLabel.getTextContent());
                                            fm.put("typeURI", typeURI.getTextContent());
                                            fm.put("entityType", foundEntityType);
                                            found = true;                                    
                                        }
                                    }
                                }
                            }
//                            if(found){
                                thdAnnots.add(startOffset, endOffset, annotationsName, fm);
//                            }
                        }
                    } else {
                        System.out.println("underlying string not present");
                    }
                }
            }
        } catch (Exception ex) {
            Logger.getLogger(TextProcessor.class.getName()).log(Level.SEVERE, null, ex);        
        }
    }
}